﻿using System;
using Microsoft.Data.Schema;
using Microsoft.Data.Schema.SchemaModel;
using MySql.Dsp.Build;
using MySql.Dsp.ScriptDom;
using MySql.Dsp.SchemaModel;


namespace MySql.Dsp
{
    internal class MySqlDatabaseSchemaProvider : DatabaseSchemaProvider
    {

        /// <summary>
        /// Establish services implemented by the DSP
        /// </summary>
        public MySqlDatabaseSchemaProvider()  
            : base(
            typeof(MySqlTaskHost.Constructor),               // * Used by IDE and command line build
            typeof(MySqlParser.Constructor),                 // * Used to parse source scripts
            typeof(MySqlModelBuilder.Constructor),           // * Used to convert parser output to model elements
            typeof(MySqlDataSchemaModel.Constructor),        // * Maintains a single instance of a model 
            typeof(MySqlScriptDomGenerator.Constructor),     // * Reproduces script dom objects from model elements
            typeof(MySqlScriptGenerator.Constructor),        // * Reproduces script from script dom objects
            typeof(MySqlSchemaDeployment.Constructor),       // * Manages deployment of a MySql model
            typeof(MySqlReverseEngineer.Constructor)         // * Used to reverse engineer from a MySql file
            )
        {
        }

        public override string FamilyName
        {
            get { throw new NotImplementedException(); }
        }

        protected override void RegisterModelTypes(ModelSchema modelSchema)
        {
            throw new NotImplementedException();
        }

        public override UserInteractionServices UserInteractionServices
        {
            get { throw new NotImplementedException(); }
        }
    }
}
